<?php
/**
 * CaptchaAd Main functionality
 */

/**
 * Write the JavaScript to the WP header
 * @global array $captchaAd_options
 * @global array $captchaAd_defaults
 */
function cadHtmlHeader()
{
	global $captchaAd_options, $captchaAd_defaults;
?>
<script type="text/javascript" src="http://master.captchaad.com/www/delivery/spcjs.php?id=<?php echo empty($captchaAd_options['PUBLISHER_ID']) ? $captchaAd_defaults['PUBLISHER_ID'] : $captchaAd_options['PUBLISHER_ID']; ?>"></script>
<script type="text/javascript" src="<?php echo $captchaAd_options['BASE_URL']; ?>3rdparty/swfobject/swfobject.js"></script>
<?php
}

/**
 * Write the CaptchaAd to the form (comment or registration)
 * @global array $captchaAd_options
 * @global array $captchaAd_defaults
 */
function cadHtmlBody()
{
	global $captchaAd_options, $captchaAd_defaults, $captchaAd_lang;

	$PUBLISHER_ID = empty($captchaAd_options['PUBLISHER_ID']) ? $captchaAd_defaults['PUBLISHER_ID'] : $captchaAd_options['PUBLISHER_ID'];

	if (empty($captchaAd_options['ZONE_ID'])) {
		$ZONE_ID = $captchaAd_lang[$captchaAd_options['LANG']]['ZONE_ID'];
	} else {
		$ZONE_ID = $captchaAd_options['ZONE_ID'];
	}

	$INPUT_LABEL = $captchaAd_lang[$captchaAd_options['LANG']]['INPUT_LABEL'];
	$CHECKBUTTON_LABEL = $captchaAd_lang[$captchaAd_options['LANG']]['CHECKBUTTON_LABEL'];

	$SESSION_ID = cadStartSession();
	$WIDTH = empty($captchaAd_options['WIDTH']) ? $captchaAd_defaults['WIDTH'] : $captchaAd_options['WIDTH'];
	$HEIGHT = empty($captchaAd_options['HEIGHT']) ? $captchaAd_defaults['HEIGHT'] : $captchaAd_options['HEIGHT'];

?>

<div class="CaptchaAdContainer">
<input type="hidden" id="CaptchaAdSwf<?php echo $ZONE_ID; ?>" name="CaptchaAdSwf" value="0" />
<input type="hidden" id="CaptchaAdInput<?php echo $ZONE_ID; ?>" name="CaptchaAdInput" value="NULL" />
<input type="hidden" name="CaptchaAdSession" value="<?php echo $SESSION_ID; ?>" />

<div id="CaptchaAdContainer<?php echo $ZONE_ID; ?>">
<script type="text/javascript">/* <![CDATA[ */
var CaptchaAd<?php echo $ZONE_ID; ?>={
ZoneId:"<?php echo $ZONE_ID; ?>",
PublisherId:"<?php echo $PUBLISHER_ID; ?>",
SessionId:"<?php echo $SESSION_ID; ?>",
AltText:"<?php echo $captchaAd_options['ALTTEXT']; ?>",
Width:"<?php echo $WIDTH; ?>",
Height:"<?php echo $HEIGHT; ?>",
InputLabel: "<?php echo $INPUT_LABEL; ?>",
CheckButtonLabel: "<?php echo $CHECKBUTTON_LABEL; ?>"
};

if (typeof OA_show == "function"){
OA_show(CaptchaAd<?php echo $ZONE_ID; ?>.ZoneId);
if(typeof CaptchaAd<?php echo $ZONE_ID; ?>.BrainId != "undefined" && CaptchaAd<?php echo $ZONE_ID; ?>.BrainId != "")
swfobject.embedSWF("<?php echo $captchaAd_options['BASE_URL']; ?>swf/CaptchaAd.swf", "CaptchaAdContainer<?php echo $ZONE_ID; ?>", "<?php echo $WIDTH; ?>", "<?php echo $HEIGHT; ?>", "10.1.0", "", CaptchaAd<?php echo $ZONE_ID; ?>);
}
/* ]]> */</script>
<script type="text/javascript" src="http://www.google.com/recaptcha/api/challenge?k=<?php echo $captchaAd_options['RECAPTCHA_PUBLIC_KEY']; ?>"></script>
<noscript>
<iframe src="http://www.google.com/recaptcha/api/noscript?k=<?php echo $captchaAd_options['RECAPTCHA_PUBLIC_KEY']; ?>" height="300" width="500" frameborder="0"></iframe><br />
<textarea name="recaptcha_challenge_field" rows="3" cols="40"></textarea>
<input type="hidden" name="recaptcha_response_field" value="manual_challenge" />
</noscript>
</div>
</div>
<?php
}

/**
 * Check the commentform
 */
function cadCheckComment($comment)
{
	// Skip cad for trackback or pingback
	if ($comment['comment_type'] != '' && $comment['comment_type'] != 'comment') {
		return $comment;
	}

	if (isset($_REQUEST['CaptchaAdSwf']) && !empty($_REQUEST['CaptchaAdSwf'])) {

		if (cadHttpPost('checkAnswer.php', array(
			's' => $_REQUEST['CaptchaAdSession'],
			'a' => $_REQUEST['CaptchaAdInput'],
			't' => 2
		)) != '1') {
			wp_die( __('Error: Answer the question in the movie, please.','captchaAdLang') );
		}
	} else {
		if(!cadCheckRecaptcha()) {
			wp_die( __('Error: Type in the shown signs, please.','captchaAdLang') );
		}
	}

	return $comment;
}

/**
 * Check the registerform
 */
function cadCheckRegistration($errors)
{
	if (isset($_REQUEST['CaptchaAdSwf']) && !empty($_REQUEST['CaptchaAdSwf'])) {

		if (cadHttpPost('checkAnswer.php', array(
			's' => $_REQUEST['CaptchaAdSession'],
			'a' => $_REQUEST['CaptchaAdInput'],
			't' => 2
		)) != '1') {
			$errors->add('CaptchaAdWrong', __('<strong>Error:</strong> Answer the question in the movie, please.','captchaAdLang'));
		}
	} else {
		if(!cadCheckRecaptcha()) {
			$errors->add('CaptchaAdWrong', __('<strong>Error:</strong> Type in the shown signs, please.','captchaAdLang'));
		}
	}

	return $errors;
}

/**
 * Check the reCAPTCHA
 * @global array $captchaAd_options
 * @return boolean
 */
function cadCheckRecaptcha()
{
	global $captchaAd_options;

	if (isset($_REQUEST['recaptcha_challenge_field']) && isset($_REQUEST['recaptcha_response_field'])) {
		if(!function_exists('recaptcha_check_answer')) {
		         include_once $captchaAd_options['BASE_PATH'] . '3rdparty/recaptcha/recaptchalib.php';
		}
		$resp = recaptcha_check_answer(
			$captchaAd_options['RECAPTCHA_PRIVATE_KEY'],
			$_SERVER['REMOTE_ADDR'],
			$_REQUEST['recaptcha_challenge_field'],
			$_REQUEST['recaptcha_response_field']
		);

		$result = $resp->is_valid;
	} else {
		$result = false;
	}

	return $result;
}

/**
 * Start the CapthaAd session
 * @global array $captchaAd_options
 * @return string Session Id or 0
 */
function cadStartSession()
{
	global $captchaAd_options;

	return cadHttpPost('startSession.php', array('k' => $captchaAd_options['API_KEY']));
}

/**
 * Do a HTTP request
 * @param string $path
 * @param array $data
 * @param int $port
 * @param int $timeout
 * @return string
 */

function cadHttpPost($path, $data, $port = 80, $timeout = 5)
{
	$host = 'server.captchaad.com';

	if (($fp = @fsockopen($host, $port, $errno, $errstr, $timeout)) === false)
	{
		return 0;
	}

	$data = http_build_query($data, '', '&');

	$post = 'POST /' . $path . " HTTP/1.1\r\n";
	$post.= 'Host: ' . $host . "\r\n";
	$post.= "Content-Type: application/x-www-form-urlencoded;\r\n";
	$post.= 'Content-Length: ' . mb_strlen($data) . "\r\n";
	$post.= "User-Agent: CaptchaAd/PHP\r\n";
	$post.= "Connection: Close\r\n\r\n";
	$post.= $data . "\r\n\r\n";

	if ((fwrite($fp, $post)) === false)
	{
		return 0;
	}

	stream_set_timeout($fp, $timeout);

	$response = '';

	$start = null;
	while (cadTestEOF($fp, $start) === false && (microtime(true) - $start) < $timeout)
	{
		if (($response.= fgets($fp, 1024)) === false)
		{
			break;
		}
	}

	if (empty($response)) {
		return 0;
	}

 	$response = explode("\r\n\r\n", $response, 2);

 	$responseBody = $response[1];

 	$responseMetaData = stream_get_meta_data($fp);

 	if (mb_strlen($responseBody) == 0
 	|| $responseMetaData['timed_out'] === true
 	|| $responseMetaData['eof'] === false
 	|| stripos($response[0], '200 OK') === false) {
 		return 0;
 	}

	if (fclose($fp) === false) {
		die('CaptchaAd: Cloud not close socket connection.');
	}

	return $responseBody;
}

/**
 * Check for end of file
 * @param resource $fp
 * @param int $start
 * @return bool
 */
function cadTestEOF($fp, &$start = null)
{
	$start = microtime(true);

	return feof($fp);
}
?>
